package cs108;

import javafx.beans.binding.Bindings;
import javafx.beans.binding.BooleanBinding;
import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleObjectProperty;

public final class PuzzleBean {
    private final ObjectProperty<Puzzle> puzzle;
    private final BooleanBinding isSolved;

    public PuzzleBean() {
        this.puzzle = new SimpleObjectProperty<>();
        this.isSolved = Bindings.createBooleanBinding(
                () -> puzzle.get() != null && puzzle.get().isSolved(),
                puzzle
        );
    }

    public Puzzle getPuzzle() {
        return puzzle.get();
    }

    public ObjectProperty<Puzzle> puzzleProperty() {
        return puzzle;
    }

    public void setPuzzle(Puzzle newPuzzle) {
        puzzle.set(newPuzzle);
    }

    public BooleanBinding isSolvedProperty() {
        return isSolved;
    }
}
